---------------------------------------------------------------------------------------------------------
-----------------------------------------[MusicPlayer]--------------------------------------------------
---------------------------------------------------------------------------------------------------------

MusicPlayerFrameOptions = {};

---------------------------------------------------------------------------------------------------------
-- Default options
---------------------------------------------------------------------------------------------------------

local MUSICPLAYER_DEFAULT_LOCK = 1;
local MUSICPLAYER_DEFAULT_SHOW_FRAME = 1;
local MUSICPLAYER_DEFAULT_SHOWSPAM = 1;
local MUSICPLAYER_DEFAULT_PLAYLISTLOC = 0;

---------------------------------------------------------------------------------------------------------
-- Global variables
---------------------------------------------------------------------------------------------------------

MP_SongIsPlaying = 0;
MusicPlayer_SongTime_START = 0;
MusicPlayer_SongTime_END = 0;
MP_OldMasterVolume = GetCVar("MasterVolume");


---------------------------------------------------------------------------------------------------------
-- Function to load a playlist when no playlist exist.
---------------------------------------------------------------------------------------------------------
MusicPlayerSongs = {};
for i = 1,6 do
	MusicPlayerSongs[i] = {};
	MusicPlayerSongs[i]["Title"] = getglobal("MP_DefaultPlaylist_"..i);
	MusicPlayerSongs[i]["Filename"] = "";
	MusicPlayerSongs[i]["Duration"] = 0;
	MusicPlayerSongs[i]["Artist"] = "";
end

---------------------------------------------------------------------------------------------------------

function MusicPlayer_PlaySong(songnumber)
	PlayMusic(MusicPlayerSongs[songnumber]["Filename"]);
	if(ShowSpam == 1)then
		if (MusicPlayerSongs[songnumber]["Title"]) then
			MPPC(""..Yellow.."<MusicPlayer> "..MusicPlayerSongs[songnumber]["Title"]);
		end
	end
	MP_SongIsPlaying = songnumber;
	MusicPlayer_SongTime_START = 0;
	MusicPlayer_SongTime_END = 0;

	MusicPlayerPlaylistUpdate();
end

function MusicPlayer_PlayNextSong()
	MusicPlayer_GetSongs();

	if (MusicPlayerFrameOptions.Shuffle == 1) then
		PlayRandomSong();
	else
		if(MP_SongIsPlaying < MusicPlayer_GetSongs())then
			MP_SongIsPlaying = MP_SongIsPlaying + 1;
		else
			MP_SongIsPlaying = 1;
		end
		MusicPlayer_PlaySong(MP_SongIsPlaying);
	end
end

function MusicPlayer_PlayPrevSong()
	MusicPlayer_GetSongs();

	if (MusicPlayerFrameOptions.Shuffle == 1) then
		PlayRandomSong();
	else

		if(MP_SongIsPlaying > 1)then
			MP_SongIsPlaying = MP_SongIsPlaying - 1;
		else
			MP_SongIsPlaying = MusicPlayer_GetSongs();
		end
		MusicPlayer_PlaySong(MP_SongIsPlaying);
	end

end

function PlayRandomSong()
	MusicPlayer_PlaySong(random(1, MusicPlayer_GetSongs()));
end

function MusicPlayer_GetSongs()
	local number = 0;
	for k,v in pairs(MusicPlayerSongs) do
		if (MusicPlayerSongs[k]["Title"] ~= "") then
			number = number + 1;
		end
	end
	return number;
end



---------------------------------------------------------------------------------------------------------

function MusicPlayerStop()
	if (MP_SongIsPlaying ~= 0) then
		StopMusic();
		if(ShowSpam == 1)then
			if (GetLocale() == "enUS") then
				MPPC(""..Yellow.."<MusicPlayer> Fading Music.");
			elseif (GetLocale() == "frFR") then
				MPPC(""..Yellow.."<MusicPlayer> Arr\195\170t.");
			end
		end
	
		MP_SongIsPlaying = 0;
		MusicPlayer_SongTime_START = 0;
		MusicPlayer_SongTime_END = 0;
	else
		if(ShowSpam == 1)then
			if (GetLocale() == "enUS") then
				MPPC(""..Yellow.."<MusicPlayer> Nothing to fade!");
			elseif (GetLocale() == "frFR") then
				MPPC(""..Yellow.."<MusicPlayer> Lecteur arr\195\170t\195\169.");
			end
		end
	end
	MusicPlayerPlaylistUpdate();
end

function MusicPlayerMute(input)
	if (input) then
		SetCVar("MasterVolume", 0)
	else
		SetCVar("MasterVolume", MP_OldMasterVolume);
	end
end

function MusicPlayer_KeybinidingVolume(dir)
	local volume = tonumber(GetCVar("MusicVolume"));
	
	if (dir == "+") then
		if (volume < 1) then
			volume = volume + 0.10;
		end
	elseif (dir == "-") then
		if (volume > 0) then
			volume = volume - 0.10;
		end
	end

	if (volume > 1) then
		volume = 1;
		SetCVar("MusicVolume", 1);
	elseif (volume < 0) then
		volume = 0;
		SetCVar("MusicVolume", 0);
	else
		SetCVar("MusicVolume", volume);
	end
	if(ShowSpam == 1)then
		local volumepercent = format("%2d", volume * 100);
		MPPC(Yellow.."<MusicPlayer> Volume: "..volumepercent.."%");
	end
end


function MusicPlayer_OptionsSliderOVC()

	MP_OnValueChanged();

	for index, value in pairs(SoundOptionsFrameSliders) do
		if ( value.index == this:GetID() ) then			
			if( value.cvar == "MasterVolume" ) then
				MP_OldMasterVolume = this:GetValue();
			end
		end
	end
end	


-------------------------------------------------------------------------------------
function MPPC(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end

function MP_Frame_Lock()
	PlaySound("igMainMenuOptionCheckBoxOn");
	MusicPlayerFrameOptions.lock = 1;

	MusicPlayerOptionsFrame_Update();
end

function MP_Frame_ToggleLock()
	if (MusicPlayerFrameOptions.lock == 1) then
		PlaySound("igMainMenuOptionCheckBoxOff");
		MusicPlayerFrameOptions.lock = 0;
		MusicPlayerFrame:SetHeight(35);
		MusicPlayerFrame:SetWidth(100);
	else
		PlaySound("igMainMenuOptionCheckBoxOn");
		MusicPlayerFrameOptions.lock = 1;
		MusicPlayerFrame:SetHeight(1);
		MusicPlayerFrame:SetWidth(1);
	end
	MusicPlayerOptionsFrame_Update();
end

function MP_Frame_UnLock()
	PlaySound("igMainMenuOptionCheckBoxOff");
	MusicPlayerFrameOptions.lock = 0;

	MusicPlayerOptionsFrame_Update();
end

-------------------------------------------------------------------------------------

function MusicPlayer_OnLoad()

	MusicPlayer_Initialize();
	this:RegisterEvent("PLAYER_LOGIN");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");

	MP_OnValueChanged = SoundOptionsSlider_OnValueChanged;
	SoundOptionsSlider_OnValueChanged = MusicPlayer_OptionsSliderOVC;
end

function MusicPlayer_Initialize()
	MPPC(MusicPlayer_Login_Msg);



	SLASH_MUSICPLAYER1 = "/musicplayer";
	SLASH_MUSICPLAYER2 = "/mp";
	SLASH_MUSICPLAYER3 = "/music";
	SlashCmdList["MUSICPLAYER"] = function(msg)
		MusicPlayer_SlashCommandHandler(msg);
	end

end

-------------------------------------------------------------------------------------


-------------------------------------------------------------------------------------

function MusicPlayer_OnEvent(event)
	if (event == "PLAYER_LOGIN") or (event == "PLAYER_ENTERING_WORLD") then
		StopMusic();
	
		MP_SongIsPlaying = 0;
		MusicPlayer_SongTime_START = 0;
		MusicPlayer_SongTime_END = 0;

		MusicPlayer_UpdateKeybindings();
		--MusicPlayerPlaylistUpdate();
	end
end

function MusicPlayer_UpdateKeybindings()
	BINDING_HEADER_MusicPlayer = "MusicPlayer";

	for k,v in pairs(MusicPlayerSongs) do
		if (MusicPlayerSongs[k]["Title"] == "") then
			setglobal("BINDING_NAME_S"..k, "Song "..k..": <Not Set>");
		else
			if MusicPlayerSongs[k]["Title"] == nil then
				MusicPlayerSongs[k]["Title"] = "";
			end
			setglobal("BINDING_NAME_S"..k, "Song "..k..": "..MusicPlayerSongs[k]["Title"]);
		end
	end

	BINDING_NAME_Fade_Music = "Fade Music";
	BINDING_NAME_Next_Song = "Next Song";
	BINDING_NAME_Previous_Song = "Previous Song";
	BINDING_NAME_MusicPlayer_Mute = "Mutes sound when held";
	BINDING_NAME_MusicPlayer_IncreaseVolume = "Increase Music Volume";
	BINDING_NAME_MusicPlayer_DecreaseVolume = "Decrease Music Volume";
end

-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------

function MusicPlayer_SlashCommandHandler(msg)
	local a, b, command = string.find( msg, "(%w+)" );

	if( command == nil ) then
		if (MusicPlayerHelpFrame:IsVisible()) then
			MusicPlayerHelpFrame:Hide();
		else
			MusicPlayerHelpFrame:Show();
		end
		return;
	else
		command = string.lower( msg );
	end

	local generated = 0;
	for k,v in pairs(MusicPlayerSongs) do
		generated = generated + 1;
	end

	for i=1,generated do
		if (command == string.lower(MusicPlayerSongs[i]["Title"])) then
			MusicPlayer_PlaySong(i);
			return;
		end
	end

	if ( command == "help" ) then
		MP_ToggleHelp();
	elseif( command == "fade" ) then
		MusicPlayerStop();
	elseif( command == "stop" ) then
		MusicPlayerStop();
	elseif( command == "stop music" ) then
		MusicPlayerStop();
	elseif( command == "end" ) then
		MusicPlayerStop();
	elseif( command == "next" ) then
		MusicPlayer_PlayNextSong();
	elseif( command == "next song" ) then
		MusicPlayer_PlayNextSong();
	elseif( command == "play next" ) then
		MusicPlayer_PlayNextSong();
	elseif( command == "previous song" ) then
		MusicPlayer_PlayPrevSong();
	elseif( command == "prev" ) then
		MusicPlayer_PlayPrevSong();
	elseif( command == "previous" ) then
		MusicPlayer_PlayPrevSong();
	elseif( command == "togglebutton" ) then
		ToggleMPButton();
	elseif( command == "tb" ) then
		ToggleMPButton();
	elseif( command == "options" ) then
		MP_ToggleOptions();
	elseif( command == "togglelock" ) then
		MP_Frame_ToggleLock();
	elseif( command == "lock" ) then
		MP_Frame_Lock();
	elseif( command == "unlock" ) then
		MP_Frame_UnLock();
	else
		MPPC(Yellow..UnknownCommand);
	end
end
--------------------------------------------------------------------------------------------------
-- Event functions
--------------------------------------------------------------------------------------------------

function MusicPlayerFrame_OnLoad()
	this:RegisterEvent("ADDON_LOADED");
end

function MusicPlayerFrame_OnEvent()

	if (event == "ADDON_LOADED" and arg1 == "MusicPlayer") then
		-- Initialize the addon
		MusicPlayerFrame_Initialize();
	end


end


function MP_UpdateDuration()
	if (MP_SongIsPlaying ~= 0) then
		Duration = MusicPlayerSongs[MP_SongIsPlaying]["Duration"];
	else
		Duration = 0;
	end
end

-- OnUpdate event
function MusicPlayerFrame_OnUpdate()

	MP_UpdateDuration();

	-- Update the time
	local Status = GetTime();

	if(Status >= MusicPlayer_SongTime_END) then
		MusicPlayer_SongTime_START = Status;
		MusicPlayer_SongTime_END = Status + Duration;
		MusicPlayer_PlayerFrame_StatusBar:SetMinMaxValues(MusicPlayer_SongTime_START, MusicPlayer_SongTime_END);
	end

	SecsRemaining = MusicPlayer_SongTime_END - Status;

	if (Duration == 0) then
		if (MP_SongIsPlaying ~= 0) then
			MusicPlayer_SongInfoFrame_Text = "";
		else
			MusicPlayer_SongInfoFrame_Text = "v"..MP_version;
		end
		MusicPlayer_PlayerFrame:SetHeight(75);
	else
		MusicPlayer_SongInfoFrame_Text = string.format("%d:%02d", SecsRemaining / 60, mod(SecsRemaining, 60));
		if (MusicPlayerFrameOptions.StatusBar == 1) then
			MusicPlayer_PlayerFrame_StatusBar:Show();
			MusicPlayer_PlayerFrame_StatusBar:SetValue(Status);
			MusicPlayer_PlayerFrame:SetHeight(95);
		else
			MusicPlayer_PlayerFrame_StatusBar:Hide();
			MusicPlayer_PlayerFrame:SetHeight(75);
		end

	end

	MusicPlayer_WhenFinished();

	MusicPlayer_PlayerFrame_SongName:SetText(MusicPlayer_PlayerFrame_SongNameText());
	MusicPlayer_PlayerFrame_SongDur:SetText(MusicPlayer_SongInfoFrame_Text);
	MusicPlayer_PlayerFrame_SongLength:SetText(MusicPlayer_PlayerFrame_SongLengthText());
end

function MusicPlayer_PlayerFrame_SongNameText()
	if (MP_SongIsPlaying ~= 0) then
		return MusicPlayerSongs[MP_SongIsPlaying]["Title"];
	else
		return "MusicPlayer";
	end
end

function MusicPlayer_PlayerFrame_SongLengthText()
	if (MP_SongIsPlaying ~= 0) then
		if (Duration == 0) then
			return "";
		else
			return string.format("%d:%02d", Duration /60, mod(Duration, 60));
		end
	else
		return "";
	end
end


function MusicPlayer_WhenFinished()
	if (SecsRemaining < 1 and SecsRemaining > 0) then

		-- Do what u want to do at tha end
		if (MUSICPLAYER_SongFinishedText_ONCE == 0) then
			if(MusicPlayerFrameOptions.PlayWhenFinished == 1)then
				if(MP_WhenFinished == 11)then
					MusicPlayer_PlayNextSong();
				elseif(MP_WhenFinished == 12)then
					PlayRandomSong();
				end
			else
				if(ShowSpam == 1)then
					if (GetLocale() == "enUS") then
						MPPC(""..Yellow.."<MusicPlayer> Song Finished.");
					elseif (GetLocale() == "frFR") then
						MPPC(""..Yellow.."<MusicPlayer> Termin\195\169 !");
					end
				end
				MusicPlayerStop();
			end
			MUSICPLAYER_SongFinishedText_ONCE = 1;
		end 
	else
		MUSICPLAYER_SongFinishedText_ONCE = 0;
	end


end

--------------------------------------------------------------------------------------------------
-- Initialize functions
--------------------------------------------------------------------------------------------------

-- Initialize the addon
function MusicPlayerFrame_Initialize()

	-- Initialize the options
	MusicPlayerFrame_InitializeOptions();
	
	-- Initialize the display
	MusicPlayerFrame_Update();

	SLASH_MUSICPLAYERFRAME1 = "/mpf";
	SLASH_MUSICPLAYERFRAME2 = "/musicplayerframe";
	SLASH_MUSICPLAYERFRAME3 = "/mpdisplay";
	SLASH_MUSICPLAYERFRAME4 = "/mpframe";
	SlashCmdList["MUSICPLAYERFRAME"] = function()
		if (MusicPlayerOptionsFrame:IsVisible()) then
			MusicPlayerOptionsFrame:Hide();
			PlaySound("igCharacterInfoClose");
		else
			MusicPlayerOptionsFrame:Show();
			PlaySound("igCharacterInfoOpen");
		end
	end
end


-- Initialize the options
function MusicPlayerFrame_InitializeOptions()
	if (MusicPlayer_Playlist == nil) then
		MusicPlayer_Playlist = MusicPlayerSongs;
	end

	if (MusicPlayerSortedSongs == nil) then
		MusicPlayerSortedSongs = MusicPlayer_Playlist;
	end

	local numgene = 0;
	for k, v in pairs(MusicPlayer_Playlist) do
		numgene = numgene + 1;
	end

	local numsorted = 0;
	for k, v in pairs(MusicPlayerSortedSongs) do
		numsorted = numsorted + 1;
	end


	local MusicPlayerCheckTable = {};


	if (numsorted < numgene) then
		for i = 1, numgene do
			MusicPlayerCheckTable[i] = {};
			MusicPlayerCheckTable[i]["Check"] = 0;
		end

		for k, v in pairs(MusicPlayer_Playlist) do
			for k1, v1 in pairs(MusicPlayerSortedSongs) do
				if (MusicPlayer_Playlist[k]["Title"] == MusicPlayerSortedSongs[k1]["Title"]) then
						MusicPlayerCheckTable[k]["Check"] = 1;
				end
			end
		end
	else
		for i = 1, numsorted do
			MusicPlayerCheckTable[i] = {};
			MusicPlayerCheckTable[i]["Check"] = 0;
		end

		for k, v in pairs(MusicPlayerSortedSongs) do
			for k1, v1 in pairs(MusicPlayer_Playlist) do
				if (MusicPlayerSortedSongs[k]["Title"] == MusicPlayer_Playlist[k1]["Title"]) then
						MusicPlayerCheckTable[k1]["Check"] = 1;
				end
			end
		end
	end



	local check = true;
	for k, v in pairs(MusicPlayerCheckTable) do
		if (MusicPlayerCheckTable[k]["Check"] == 0) then
			check = false;
		end
	end

	if (check == true) then
		MusicPlayerSongs = MusicPlayerSortedSongs;
	else
		MusicPlayerSongs = MusicPlayer_Playlist;
		MusicPlayerSortedSongs = MusicPlayerSongs;
	end
	--------------------------------------------------------------------------------------------


	-- Check the show Frame option
	if (not MusicPlayerFrameOptions.showFrame == 1 and not MusicPlayerFrameOptions.showFrame == 0) then
		MusicPlayerFrameOptions.showFrame = 1;
	end

	-- Check the lock option
	if (not MusicPlayerFrameOptions.lock == 1 and not MusicPlayerFrameOptions.lock == 0) then
		MusicPlayerFrameOptions.lock = 1;
	end


	--check the showspam button
	if (not MusicPlayerFrameOptions.ShowSpam == 1 and not MusicPlayerFrameOptions.ShowSpam == 0) then
		MusicPlayerFrameOptions.ShowSpam = 0;
	end


	if (MusicPlayerFrameOptions.PlaylistLoc == nil) then
		MusicPlayerFrameOptions.PlaylistLoc = 2;
	end

	if (not MusicPlayerFrameOptions.Color) then
		MusicPlayerFrameOptions.Color = {};

		if (not MusicPlayerFrameOptions["Color"][1]) then
			MusicPlayerFrameOptions["Color"][1] = {};
			MusicPlayerFrameOptions["Color"][2] = {};
			MusicPlayerFrameOptions["Color"][3] = {};
			MusicPlayerFrameOptions["Color"][4] = {};

			MusicPlayerFrameOptions["Color"][1][1] = 1;
			MusicPlayerFrameOptions["Color"][1][2] = 0;
			MusicPlayerFrameOptions["Color"][1][3] = 0;

			MusicPlayerFrameOptions["Color"][2][1] = 0;
			MusicPlayerFrameOptions["Color"][2][2] = 0;
			MusicPlayerFrameOptions["Color"][2][3] = 0;

			MusicPlayerFrameOptions["Color"][3][1] = 0.5;
			MusicPlayerFrameOptions["Color"][3][2] = 0.5;
			MusicPlayerFrameOptions["Color"][3][3] = 0.5;

			MusicPlayerFrameOptions["Color"][4][1] = 1;
			MusicPlayerFrameOptions["Color"][4][2] = 0;
			MusicPlayerFrameOptions["Color"][4][3] = 0;
		end
	end


	if (not MusicPlayerFrameOptions.PlaylistText) then
		MusicPlayerFrameOptions.PlaylistText = {};

		if (not MusicPlayerFrameOptions["PlaylistText"]["Name"]) then
			MusicPlayerFrameOptions["PlaylistText"]["Name"] = 1;
			MusicPlayerFrameOptions["PlaylistText"]["Dur"] = 1;
			MusicPlayerFrameOptions["PlaylistText"]["Number"] = 0;
			MusicPlayerFrameOptions["PlaylistText"]["Artist"] = 0;
			--MusicPlayerFrameOptions["PlaylistText"][""] = 0;
		end
	end
	

	if (not MusicPlayerFrameOptions.PlayerFrameStrata) then
		MusicPlayerFrameOptions.PlayerFrameStrata = 2;
	end

	if (not MusicPlayerFrameOptions.PlayerWidth) then
		MusicPlayerFrameOptions.PlayerWidth = 150;
	end

	if (not MusicPlayerFrameOptions.StatusBar == 1 and not MusicPlayerFrameOptions.StatusBar == 0) then
		MusicPlayerFrameOptions.StatusBar = 1;
	end

	if (not MusicPlayerFrameOptions.Shuffle) then
		MusicPlayerFrameOptions.Shuffle = 0;

	elseif (MusicPlayerFrameOptions.Shuffle == 1) then
		MP_WhenFinished = 12;

	elseif (MusicPlayerFrameOptions.Shuffle == 0) then
		MP_WhenFinished = MusicPlayerFrameOptions.WhenFinished;
	end



	MusicPlayerOptionsFrame:Show();
	MusicPlayerOptionsFrame:Hide();
end

function MusicPlayerFrame_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_LEFT");
	if (MusicPlayer_PlayerFrame:IsVisible()) then
		if (MusicPlayerFrameOptions.lock ~= 1) then
			GameTooltip:SetText(MusicPlayer_SongNameFrame_Click);
		end
	end
end

function MP_ToggleHelp()
	if (MusicPlayerHelpFrame:IsVisible()) then
		MusicPlayerOptionsFrameShowHelp:SetText(MUSICPLAYER_HELP);
		MusicPlayerHelpFrame:Hide();
		PlaySound("igCharacterInfoClose");
	else
		MusicPlayerOptionsFrameShowHelp:SetText(MUSICPLAYER_THX);
		MusicPlayerHelpFrame:Show();
		PlaySound("igCharacterInfoOpen");
	end
end

function MP_ToggleOptions()
	if (MusicPlayerOptionsFrame:IsVisible()) then
		MusicPlayerOptionsFrame:Hide();
		PlaySound("igCharacterInfoClose");
	else
		MusicPlayerOptionsFrame:Show();
		PlaySound("igCharacterInfoOpen");
	end

end

--------------------------------------------------------------------------------------------------
-- Display functions
--------------------------------------------------------------------------------------------------

function MusicPlayerFrame_Update()
	
	-- Check the show Frame option
	if (MusicPlayerFrameOptions.showFrame) then
		MusicPlayer_PlayerFrame:Show();
	else
		MusicPlayer_PlayerFrame:Hide();
	end

	-- Check the Song Info option
	if (MusicPlayerFrameOptions.PlaylistLoc == 1) then
		MusicPlayer_PlayerFrame_Playlist:ClearAllPoints();
		MusicPlayer_PlayerFrame_Playlist:SetPoint("BOTTOM", "MusicPlayer_PlayerFrame", "TOP");
	elseif (MusicPlayerFrameOptions.PlaylistLoc == 2) then
		MusicPlayer_PlayerFrame_Playlist:ClearAllPoints();
		MusicPlayer_PlayerFrame_Playlist:SetPoint("TOP", "MusicPlayer_PlayerFrame", "BOTTOM");
	elseif (MusicPlayerFrameOptions.PlaylistLoc == 3) then
		MusicPlayer_PlayerFrame_Playlist:ClearAllPoints();
		MusicPlayer_PlayerFrame_Playlist:SetPoint("RIGHT", "MusicPlayer_PlayerFrame", "LEFT");
	elseif (MusicPlayerFrameOptions.PlaylistLoc == 4) then
		MusicPlayer_PlayerFrame_Playlist:ClearAllPoints();
		MusicPlayer_PlayerFrame_Playlist:SetPoint("TOPRIGHT", "MusicPlayer_PlayerFrame", "TOPLEFT");
	elseif (MusicPlayerFrameOptions.PlaylistLoc == 5) then
		MusicPlayer_PlayerFrame_Playlist:ClearAllPoints();
		MusicPlayer_PlayerFrame_Playlist:SetPoint("BOTTOMRIGHT", "MusicPlayer_PlayerFrame", "BOTTOMLEFT");
	elseif (MusicPlayerFrameOptions.PlaylistLoc == 6) then
		MusicPlayer_PlayerFrame_Playlist:ClearAllPoints();
		MusicPlayer_PlayerFrame_Playlist:SetPoint("LEFT", "MusicPlayer_PlayerFrame", "RIGHT");
	elseif (MusicPlayerFrameOptions.PlaylistLoc == 7) then
		MusicPlayer_PlayerFrame_Playlist:ClearAllPoints();
		MusicPlayer_PlayerFrame_Playlist:SetPoint("TOPLEFT", "MusicPlayer_PlayerFrame", "TOPRIGHT");
	elseif (MusicPlayerFrameOptions.PlaylistLoc == 8) then
		MusicPlayer_PlayerFrame_Playlist:ClearAllPoints();
		MusicPlayer_PlayerFrame_Playlist:SetPoint("BOTTOMLEFT", "MusicPlayer_PlayerFrame", "BOTTOMRIGHT");
	end

	-- Check the ShowSpam option
	if (MusicPlayerFrameOptions.ShowSpam) then
		ShowSpam = 1;
	else
		ShowSpam = 0;
	end

	--
	MusicPlayer_PlayerFrame:SetBackdropColor(MusicPlayerFrameOptions.Color[2][1], MusicPlayerFrameOptions.Color[2][2], MusicPlayerFrameOptions.Color[2][3]);
	MusicPlayer_PlayerFrame:SetBackdropBorderColor(MusicPlayerFrameOptions.Color[3][1], MusicPlayerFrameOptions.Color[3][2], MusicPlayerFrameOptions.Color[3][3]);

	MusicPlayer_PlayerFrame_Window:SetBackdropBorderColor(MusicPlayerFrameOptions.Color[3][1], MusicPlayerFrameOptions.Color[3][2], MusicPlayerFrameOptions.Color[3][3]);

	MusicPlayer_PlayerFrame_Playlist:SetBackdropColor(MusicPlayerFrameOptions.Color[2][1], MusicPlayerFrameOptions.Color[2][2], MusicPlayerFrameOptions.Color[2][3]);
	MusicPlayer_PlayerFrame_Playlist:SetBackdropBorderColor(MusicPlayerFrameOptions.Color[3][1], MusicPlayerFrameOptions.Color[3][2], MusicPlayerFrameOptions.Color[3][3]);

	MusicPlayer_PlayerFrame_Playlist_SongsText:SetTextColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);
	MusicPlayer_PlayerFrame_BottomBar:SetVertexColor(MusicPlayerFrameOptions.Color[3][1], MusicPlayerFrameOptions.Color[3][2], MusicPlayerFrameOptions.Color[3][3]);

	MusicPlayer_PlayerFrame_Playlist_ShuffleText:SetTextColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);
	MusicPlayer_PlayerFrame_Playlist_ShuffleNormalTexture:SetVertexColor(MusicPlayerFrameOptions.Color[3][1], MusicPlayerFrameOptions.Color[3][2], MusicPlayerFrameOptions.Color[3][3]);
	MusicPlayer_PlayerFrame_Playlist_ShufflePushedTexture:SetVertexColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);
	MusicPlayer_PlayerFrame_Playlist_ShuffleCheckedTexture:SetVertexColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);
	MusicPlayer_PlayerFrame_Playlist_ShuffleHighlightTexture:SetVertexColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);	

	MusicPlayer_PlayerFrame_Fade_Text:SetTextColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);
	MusicPlayer_PlayerFrame_Toggle_Text:SetTextColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);

	MusicPlayer_PlayerFrame_SongName:SetTextColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);
	MusicPlayer_PlayerFrame_SongDur:SetTextColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);
	MusicPlayer_PlayerFrame_SongLength:SetTextColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);

	MusicPlayer_PlayerFrame_StatusBar:SetStatusBarColor(MusicPlayerFrameOptions.Color[4][1], MusicPlayerFrameOptions.Color[4][2], MusicPlayerFrameOptions.Color[4][3]);
	
	for i=1,10 do
		local name = "MusicPlayerPlaylist_Button"..i.."_Name";

		getglobal(name):SetWidth(MusicPlayerFrameOptions.PlayerWidth - 60);

		local time = "MusicPlayerPlaylist_Button"..i.."_Time";
		local button = "MusicPlayerPlaylist_Button"..i.."_MusicPlayerPlaylist_BeingPlayedTexture";
		local highlight = "MusicPlayerPlaylist_Button"..i.."_HighlightTexture";
		getglobal(name):SetTextColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);
		getglobal(time):SetTextColor(MusicPlayerFrameOptions.Color[1][1], MusicPlayerFrameOptions.Color[1][2], MusicPlayerFrameOptions.Color[1][3]);	
		getglobal(button):SetVertexColor(MusicPlayerFrameOptions.Color[4][1], MusicPlayerFrameOptions.Color[4][2], MusicPlayerFrameOptions.Color[4][3]);
		getglobal(highlight):SetVertexColor(MusicPlayerFrameOptions.Color[3][1], MusicPlayerFrameOptions.Color[3][2], MusicPlayerFrameOptions.Color[3][3]);
	end

	if (MusicPlayerFrameOptions.PlayerFrameStrata == 1) then
		MusicPlayer_PlayerFrame:SetFrameStrata("LOW");
	elseif (MusicPlayerFrameOptions.PlayerFrameStrata == 2) then
  		MusicPlayer_PlayerFrame:SetFrameStrata("MEDIUM");
	elseif (MusicPlayerFrameOptions.PlayerFrameStrata == 3) then
		MusicPlayer_PlayerFrame:SetFrameStrata("HIGH");
	end

	MusicPlayer_PlayerFrame_Playlist:SetWidth(MusicPlayerFrameOptions.PlayerWidth);
	MusicPlayer_PlayerFrame_Playlist_List_ScrollFrame:SetWidth(MusicPlayerFrameOptions.PlayerWidth - 34);
	MusicPlayer_PlayerFrame_BottomBar:SetWidth(MusicPlayerFrameOptions.PlayerWidth - 8.5);

	for i=1,10 do
		getglobal("MusicPlayerPlaylist_Button"..i):SetWidth(MusicPlayerFrameOptions.PlayerWidth - 34);
		getglobal("MusicPlayerPlaylist_Button"..i.."_MusicPlayerPlaylist_BeingPlayedTexture"):SetWidth(MusicPlayerFrameOptions.PlayerWidth - 34);
		getglobal("MusicPlayerPlaylist_Button"..i.."_HighlightTexture"):SetWidth(MusicPlayerFrameOptions.PlayerWidth - 34);
	end
	
end

function MusicPlayer_PlayerFrame_Shuffle()
	MusicPlayerFrameOptions.Shuffle = this:GetChecked();

	if (MusicPlayerFrameOptions.Shuffle == 1) then
		MP_WhenFinished = 12;
	else
		MP_WhenFinished = MusicPlayerFrameOptions.WhenFinished;
	end
end


------------------------------MusicPlayer PlayList--------------------------------


function MusicPlayerPlaylistUpdate()
	local offset;

	FauxScrollFrame_Update(MusicPlayer_PlayerFrame_Playlist_List_ScrollFrame, MusicPlayer_GetSongs(), 10, 20);

	for button = 1,10 do
		offset = button + FauxScrollFrame_GetOffset(MusicPlayer_PlayerFrame_Playlist_List_ScrollFrame);
		if (offset <= MusicPlayer_GetSongs()) then
			local texture = "MusicPlayerPlaylist_Button"..button.."_MusicPlayerPlaylist_BeingPlayedTexture";
			if (MP_SongIsPlaying == offset) then
				getglobal(texture):Show();
			else
				getglobal(texture):Hide();
			end

			local text = "MusicPlayerPlaylist_Button"..button.."_Name";

			getglobal(text):SetText(MusicPlayerSongs[offset]["Title"]);

			local text = "MusicPlayerPlaylist_Button"..button.."_Time";

			if (MusicPlayerSongs[offset]["Duration"] ~= 0 and MusicPlayerSongs[offset]["Duration"] ~= nil) then
				getglobal(text):SetText(string.format("%d:%02d", MusicPlayerSongs[offset]["Duration"] / 60, mod(MusicPlayerSongs[offset]["Duration"], 60)));
			else
				getglobal(text):SetText("");
			end

			getglobal("MusicPlayerPlaylist_Button"..button):Show();
		else
			getglobal("MusicPlayerPlaylist_Button"..button):Hide();
		end


	end

	-- song nr / maxsongs
	if (MP_SongIsPlaying ~= 0) then
		MusicPlayer_PlayerFrame_Playlist_SongsText:SetText(MP_SongIsPlaying.." / "..MusicPlayer_GetSongs());
	else
		MusicPlayer_PlayerFrame_Playlist_SongsText:SetText(MusicPlayer_GetSongs());
	end

	
end

function MusicPlayer_PlayerFrame_OnMouseUp(arg)
	if (arg == "LeftButton") then
		this:StopMovingOrSizing();
	end
end

